%Maximum likelihood estimation of analytical model
load AnalyticalDataFed;
load InputDataFed;
Nobs = length(Yields);
[Gamma0,Gamma]=TaylorRule(FedFunds,States);
%Analytical analytical model
display('Powell Search')
FTol = 1e-2;
XTol = sqrt(eps);
ThetaA = AnalyticalPowell( ForecastsA,FTol,Gamma0,Gamma,Returns,SigmaSA,SA,ThetaA,Xinf,XTol,Yields );
[NLLA,ImplicitStatesA]= AnalyticalNLL(ThetaA,ForecastsA,Gamma0,Gamma,Returns,SigmaSA,SA,Xinf,Yields);
LogLikelihoodA = -NLLA;
display(LogLikelihoodA);
save AnalyticalDataFed ImplicitStatesA LogLikelihoodA ThetaA  
iswitch = 0;
if iswitch == 1
    display('fminsearch')
    XTol = 1e-4;
    FTol = 1e-2;
    options=optimset('Display','final','TolFun',FTol,'TolX',XTol);
    exitflag = 0;
    while exitflag < 1;
        [ThetaA,~,exitflag]=fminsearch(@AnalyticalNLL,ThetaA,options,ForecastsA,Gamma0,Gamma,Returns,SigmaSA,SA,Xinf,Yields);
        [NLLA,ImplicitStatesA]= AnalyticalNLL(ThetaA,ForecastsA,Gamma0,Gamma,Returns,SigmaSA,SA,Xinf,Yields);
        LogLikelihoodA = -NLLA;
        display(LogLikelihoodA);
        SigmaRA = ThetaA(13);
        display(SigmaRA)
        save AnalyticalDataFed ImplicitStatesA LogLikelihoodA ThetaA  
    end
end
[NLLA,ImplicitStatesA,AlphaA,BetaA]= AnalyticalNLL(ThetaA,ForecastsA,Gamma0,Gamma,Returns,SigmaSA,SA,Xinf,Yields);
LogLikelihoodA = -NLLA;
display(LogLikelihoodA)
EquilibriumA = AlphaA+Xinf*BetaA;
%Calculate Fitting Errors
YvolA = sqrt(12*diag(BetaA'*SigmaSA*BetaA))';
ResidualsA= Yields-ones(Nobs,1)*AlphaA-ImplicitStatesA*BetaA;
VolEA = std(ResidualsA(:,2:end),1);
%Calculate asymptotic standard errors
N = length(ThetaA);
Eye = eye(N);
DLLA = zeros(Nobs,N);
for n = 1:N;
    Thetaup = ThetaA + XTol*Eye(n,:);
    [~,~,~,~,~,~,~,LLup(:,1)] = AnalyticalNLL(Thetaup,ForecastsA,Gamma0,Gamma,Returns,SigmaSA,SA,Xinf,Yields);
    Thetadown = ThetaA - XTol*Eye(n,:);
    [~,~,~,~,~,~,~,LLdown(:,1)] = AnalyticalNLL(Thetadown,ForecastsA,Gamma0,Gamma,Returns,SigmaSA,SA,Xinf,Yields);
    for t = 1:Nobs
        DLLA(t,n) = (LLup(t,1)- LLdown(t,1))/(2*XTol);
    end
end
SEA = sqrt(diag(inv(DLLA'*DLLA)))';

save AnalyticalDataFed ImplicitStatesA LogLikelihoodA SEA ThetaA