function[NLLA,ImplicitStatesA,AlphaA,BetaA,ExpectedReturnsA,XReturnsA,ReturnVolA,LLA]= AnalyticalNLL(ThetaA,ForecastsA,Gamma0,Gamma,Returns,SigmaSA,SA,Xinf,Yields)
    %define parameters 
    [Nobs,Nbonds] = size(Yields);
    Ones = ones(Nobs,1);
    MuQA=ThetaA(1:3);
    ThQA=[ThetaA(4:6)
          ThetaA(7:9)
          ThetaA(10:12)];
    MPA = [ThetaA(13:15)
            ThetaA(16:18)
            ThetaA(19:21)];
    SigmaRA = ThetaA(22);
    SRetA = [ThetaA(23:25);
            0,ThetaA(26:27)
            0,0,ThetaA(28)];
    
    CPA = Xinf*(eye(3)-MPA);
    SigmaRetA = SRetA'*SRetA;
    AlphaA = zeros(1,Nbonds);
    BetaA = zeros(3,Nbonds);
    AlphaHA = zeros(1,Nbonds);
    BetaHA = zeros(3,Nbonds);
    AlphaHatA = zeros(1,Nbonds);
    BetaHatA = zeros(3,Nbonds);
    GammaTildeA = ThQA\Gamma;
    for n = 1:Nbonds
        BetaA(:,n)=(eye(3)-expm(-ThQA*n))*GammaTildeA/n;
        BetaHA(:,n)= (eye(3)-expm(-ThQA*(n-1/12)))*GammaTildeA/(n-1/12);
        BetaHatA(:,n)=12*(BetaA(:,n)*n - MPA*BetaHA(:,n)*(n-1/12));
        AlphaA(1,n) = Gamma0 + MuQA*Gamma - MuQA*BetaA(:,n) - 0.5*Gamma'*SigmaIntOU(n,ThQA',SA)*Gamma/n;
        AlphaHA(1,n) = Gamma0 + MuQA*Gamma - MuQA*BetaHA(:,n) - 0.5*Gamma'*SigmaIntOU(n-1/12,ThQA',SA)*Gamma/(n-1/12);
        AlphaHatA(1,n) = 12*(n*AlphaA(n)-(n-1/12)*AlphaHA(1,n)-CPA*BetaHA(:,n)*(n-1/12));
    end
    YvolA = sqrt(12*diag(BetaA'*SigmaSA*BetaA))';
    ReturnVolA = zeros(1,Nbonds);
    for n = 1:Nbonds;
        ReturnVolA(n) = n*YvolA(n);
    end
    BetaAmonth=(eye(3)-expm(-ThQA/12))*GammaTildeA*12;
    AlphaAmonth = Gamma0 + MuQA*Gamma - MuQA*BetaAmonth - 0.5*Gamma'*SigmaIntOU(1/12,ThQA',SA)*Gamma*12;
    %SigmaSxiA = SigmaOU(1/12,ThA',SSP);
    %ReturnVolA = sqrt(12*diag(BetaHatA'*SigmaSxiA*BetaHatA))';
    BA = BetaA(:,2:Nbonds);
    AA = AlphaA(:,2:Nbonds);
    BHatA = BetaHatA(:,[2,10,30]);
    AHatA = AlphaHatA(1,[2,10,30]);
    Ret = Returns(:,[2,10,30]);
    Omega = inv(SigmaSA) + BA*BA'/SigmaRA^2 + BHatA/SigmaRetA*BHatA';
    ImplicitStatesA = (ForecastsA/SigmaSA + ((Yields(:,2:Nbonds)-Ones*AA)*BA')/SigmaRA^2 + (Ret-Ones*AHatA)/SigmaRetA*BHatA')/Omega;
    ExpectedReturnsA = Ones*AlphaHatA + ImplicitStatesA*BetaHatA;
    RFmonthA = Ones*AlphaAmonth + ImplicitStatesA*BetaAmonth;
    XReturnsA = ExpectedReturnsA-RFmonthA*ones(1,Nbonds);
    ResidualsYA = Yields(:,2:Nbonds)-Ones*AA-ImplicitStatesA*BA;
    ResidualsSA = ForecastsA - ImplicitStatesA;
    ResidualsRetA = Ret-Ones*AHatA-ImplicitStatesA*BHatA;
    [~,Nret] = size(ResidualsRetA);
    LLA = zeros(Nobs,1);
    for t = 1:Nobs;
        LLA(t,1) = -0.5*(3*log(2*pi)+log(det(SigmaSA))+ResidualsSA(t,:)/SigmaSA*ResidualsSA(t,:)')-0.5*((Nbonds-1)*(log(2*pi)+log(SigmaRA^2))+ResidualsYA(t,:)*ResidualsYA(t,:)'/SigmaRA^2);
        LLA(t,1) = LLA(t,1)-0.5*(Nret*log(2*pi)+log(det(SigmaRetA))+ResidualsRetA(t,:)/SigmaRetA*ResidualsRetA(t,:)');
    end
    LogLikelihoodA = sum(LLA);
    %display(LogLikelihoodA);
    NLLA = -LogLikelihoodA;
end