%load data 
load InputDataFed.mat;
savefile = 'ModelDataFed28275';
load(savefile)
XTol = sqrt(eps);
[Nobs,Nbonds]=size(Yields);
[Gamma0,Gamma]=TaylorRule(FedFunds,States);
%Find asymptotic standard errors
display('Finding Standard Errors')
Nparam = length(Theta);
PriceParam = 24;
Eye = eye(Nparam);
DLL = zeros(Nobs,Nparam);
parfor n = 1:PriceParam;
    display(n);
    Thetaup = Theta + XTol*Eye(n,:);
    [Pricesup,PricesHup]=CalculatePrices(Delta,Gamma0,Gamma,H,MaxD,MinD,Snp,Szp,Thetaup,Nbonds);
    [~,~,~,~,~,~,~,~,~,~,LLup] = CalculateLogLikelihood(Delta,Forecasts,Gamma0,Gamma,H,ImplicitStates,MaxD,MinD,Pricesup,PricesHup,Returns,SigmaSnp,SigmaSzp,Snp,Szp,Thetaup,Xinf,Yields);
    Thetadown = Theta - XTol*Eye(n,:);
    [Pricesdown,PricesHdown]=CalculatePrices(Delta,Gamma0,Gamma,H,MaxD,MinD,Snp,Szp,Thetadown,Nbonds);
    [~,~,~,~,~,~,~,~,~,~,LLdown] = CalculateLogLikelihood(Delta,Forecasts,Gamma0,Gamma,H,ImplicitStates,MaxD,MinD,Pricesdown,PricesHdown,Returns,SigmaSnp,SigmaSzp,Snp,Szp,Thetadown,Xinf,Yields);
    for t = 1:Nobs
        DLL(t,n) = (LLup(t)- LLdown(t))/(2*XTol);
    end
end
if( Nparam > PriceParam)
    parfor n = PriceParam+1:Nparam;
        display(n);
        Thetaup = Theta + XTol*Eye(n,:);
        [~,~,~,~,~,~,~,~,~,~,LLup] = CalculateLogLikelihood(Delta,Forecasts,Gamma0,Gamma,H,ImplicitStates,MaxD,MinD,Prices,PricesH,Returns,SigmaSnp,SigmaSzp,Snp,Szp,Thetaup,Xinf,Yields);
        Thetadown = Theta - XTol*Eye(n,:);
        [~,~,~,~,~,~,~,~,~,~,LLdown] = CalculateLogLikelihood(Delta,Forecasts,Gamma0,Gamma,H,ImplicitStates,MaxD,MinD,Prices,PricesH,Returns,SigmaSnp,SigmaSzp,Snp,Szp,Thetadown,Xinf,Yields);
        for t = 1:Nobs
            DLL(t,n) = (LLup(t,1)- LLdown(t,1))/(2*XTol);
        end
    end
end
SE = sqrt(diag(inv(DLL'*DLL)))';
%save results of search and SE calculation
temp = strcat(savefile,'SE');%name of search output file
save( temp,'DLL','SE');