function[LogLikelihoodTIPS,SigmaRTIPS,Residuals,N,LL,VolETIPS] = TIPSCalculateLogLikelihood(Delta,FedFundsTIPS,ForecastsTIPS,ImplicitStatesTIPS,MaxD,MinD,PricesTIPS,SigmaSnp,SigmaSzp,YieldsTIPS)
    % Finds SigmaR and LogLikelihood  
    FFmin = 0.0025;
    [Nobs,Nbonds] = size(YieldsTIPS);
    ModelYieldsTIPS = zeros(Nobs,Nbonds+1);
    for t = 1:Nobs;
        ModelYieldsTIPS(t,:) = Interpolate(Delta,ImplicitStatesTIPS(t,:),MaxD, MinD,Nbonds+1,PricesTIPS);
    end
    ModelYieldsTIPS = ModelYieldsTIPS(:,2:Nbonds+1);
    NTIPS = zeros(Nobs,Nbonds);
    Residuals = zeros(Nobs,Nbonds);
    for t = 1:Nobs;
        for n = 1:Nbonds
            if(YieldsTIPS(t,n) ~= 0.0 )
                Residuals(t,n) = YieldsTIPS(t,n) - ModelYieldsTIPS(t,n);
                NTIPS(t,n) = 1;
            end
        end
    end
    M = sum(NTIPS,2);
    SSE = diag(Residuals'*Residuals)';
    VolETIPS = sqrt(SSE./sum(NTIPS));
    N = sum(sum(NTIPS));
    SigmaRTIPS = sqrt(sum(SSE)/N);
    LL = zeros(Nobs,1);
    for t = 1:Nobs
        if FedFundsTIPS(t) < FFmin
            LL(t,1) = -0.5*((3+M(t))*log(2*pi))-0.5*M(t)*(log(SigmaRTIPS^2))-0.5*trace((ForecastsTIPS(t,:)-ImplicitStatesTIPS(t,:))/SigmaSzp*(ForecastsTIPS(t,:)-ImplicitStatesTIPS(t,:))')-0.5*log(det(SigmaSzp))-0.5*Residuals(t,:)*Residuals(t,:)'/SigmaRTIPS^2;
        else
            LL(t,1) = -0.5*((3+M(t))*log(2*pi))-0.5*M(t)*(log(SigmaRTIPS^2))-0.5*trace((ForecastsTIPS(t,:)-ImplicitStatesTIPS(t,:))/SigmaSnp*(ForecastsTIPS(t,:)-ImplicitStatesTIPS(t,:))')-0.5*log(det(SigmaSnp))-0.5*Residuals(t,:)*Residuals(t,:)'/SigmaRTIPS^2;
        end
    end
    LogLikelihoodTIPS = sum(LL);
end
