%This is the main function for the non-linear term structure model parameter and implicit state search

clear all;

%load data
load InputDataFed.mat;
savefile = 'ModelDataFed28275';
load(savefile)
XTol = sqrt(eps);%absolute tolerance for states changes in searches
FTol = 0.1;%absolute tolerance for function changes in searches
[Gamma0,Gamma]=TaylorRule(FedFunds,States);
%Update ImplicitStates to correct length if needed
LIS = length(ImplicitStates);
Nobs = length(Yields);
if( LIS < Nobs);
    AddStates = zeros(Nobs-LIS,3);
    for ii = 1: Nobs-LIS;
        AddStates(ii,:) = ImplicitStates(LIS,:);
    end
    ImplicitStates = [ImplicitStates
                     AddStates];
end

%Find optimal Theta and ImplicitStates using Powell search.
display('POWELL SEARCH')
[NLL,Theta,ImplicitStates] = Powell( Delta,Forecasts,FTol,Gamma0,Gamma,H,ImplicitStates,MaxD,MinD,Returns,savefile,SigmaSnp,SigmaSzp,Snp,Szp,Theta,Xinf,XTol,Yields );